#!/usr/bin/perl

# SM guestbook v 2.6 by Super-M, 2003-2023

%data = &get_data();
if($ENV{'REMOTE_HOST'} ne ""){ $remotehost = $ENV{'REMOTE_HOST'}; }
else { $remotehost = $ENV{'REMOTE_ADDR'}; } 

%Cookie_Encode_Chars = ('\%',   '%25',
                        '\+',   '%2B',
                        '\;',   '%3B',
                        '\,',   '%2C',
                        '\=',   '%3D',
                        '\&',   '%26',
                        '\:\:', '%3A%3A',
                        '\s',   '+');

%Cookie_Decode_Chars = ('\+',       ' ',
                        '\%3A\%3A', '::',
                        '\%26',     '&',
                        '\%3D',     '=',
                        '\%2C',     ',',
                        '\%3B',     ';',
                        '\%2B',     '+',
                        '\%25',     '%');

@sbbcodes = ('B', 'I', 'U', 'S', 'SUP', 'SUB', 'BIG', 'SMALL', 'CODE', 'KBD', 'CENTER');
@fbbcodes = ('SIZE', 'COLOR', 'FACE');

if ($ENV{'HTTP_COOKIE'}) {
  foreach (split(/; /,$ENV{'HTTP_COOKIE'})) {
    ($cookie,$value) = split(/=/);
    foreach $char (keys %Cookie_Decode_Chars) {
      $cookie =~ s/$char/$Cookie_Decode_Chars{$char}/g;
      $value =~ s/$char/$Cookie_Decode_Chars{$char}/g;
      }
    $Cookies{$cookie} = $value;
    }
  $amask = $Cookies{'amask'};
  $apw = $Cookies{'apass'};
  }
else { $amask=""; $apw=""; }

$admName="ADMINISTRATOR";
$admPassw="PASSWORD";
$admLinkNick="User";

$cmd = $data{'c'};
$err_msg=""; $addhdr = "";
$isadm=0; $pagesz=10;
$pw = $data{'pass'};
# $amask = $data{'amask'};
# $apw = $data{'apass'};
if (($amask eq $admName)&&($apw eq $admPassw)) { $isadm=1; }

if ((! $cmd)||($cmd eq "")) {
 $cmd = "PrintAll";
 }

$path_to_gest = "/home/l/luminopher.h1.ru/WWW/gbk/.gb";
$gest_url = "gest.cgi";
$time = time;

if($cmd eq "PrintAll"){
   &show_all;
   }
elsif($cmd eq "Add"){
   &add_msg;
   }
elsif($cmd eq "Answer"){
   &add_answ;
   }
elsif($cmd eq "Login"){
   &do_login;
   }
elsif($cmd eq "Delete"){
   &del_msg;
   }

print "Pragma: no-cache\nContent-Type: text/html; charset=windows-1251\n\n";
print <<EOF;
       <html><head><title>$remotehost :    </title>
       <link rel=stylesheet href="/gbk/styles.css" type="text/css"></head>
       <body><h1>$remotehost :    </h1>
       <p><b>      .
        ,  .</b></p>
       <p>   .       ,
         .      
        .  .</p></body></html>
EOF


sub show_all {
my($modenote) = "";
my($pageinfo);
my($pnum);
$mnum = $data{'m'} - 0;
if ($mnum < 0) { $mnum=0; }
$pnum = $mnum / $pagesz;
$pnum++; $nmsgs=0;
if ($isadm == 1){
 $modenote = "<p align=\"center\"> <b></b></p>";
 }
elsif ($apw ne ""){
 $modenote = &encode_misc($amask);
 $modenote = "<p align=\"center\">  <b> </b>
   <b>$modenote</b></p>";
 }
$pageinfo = "<p><b><a href=\"#pg\"></a>: $pnum</b></p>";
if ($amask ne ""){
 $value = &encode_cookie($amask);
 $addhdr .= "Set-Cookie: amask=$value\n";
 $value = &encode_cookie($apw);
 $addhdr .= "Set-Cookie: apass=$value\n";
 }
print "Pragma: no-cache\n$addhdr";
print "Content-Type: text/html; charset=windows-1251\n\n";
print "<html><head><title>$admLinkNick : oa</title>\n";
print "<link rel=stylesheet href=\"/gbk/styles.css\" type=\"text/css\">\n";
print "<script language=\"JavaScript\" src=\"/gbk/gb.js\"></script></head>\n";
print "<body><h1>$admLinkNick : oa
<noscript>
       JavaScript!  JavaScript       
</noscript></h1>$err_msg\n<p><a href=\"$gest_url\">
 </a></p>\n$modenote\n$pageinfo\n<table width=\"100%\">\n";
open(FILE, "<$path_to_gest");
while(<FILE>){
 if (($nmsgs >= $mnum)&&($nmsgs < $mnum+$pagesz)){
   ($umid,$nick,$password,$cont,$msg,$answer,$us,$ip,$date)=split(/\t/, $_);
   &print_msg;
   }
 $nmsgs++;
 }
close(FILE);
$pageinfo .= "<tr><td colspan=2 class=\"pages\"><a name=\"pg\"></a>";
if ($nmsgs > $pagesz){
 my($vpnum)=1;
 my($curmnum);
 $pageinfo .= "  :";
 for ($curmnum = 0; $curmnum < $nmsgs; $curmnum += $pagesz){
   if ($curmnum == $mnum){ $pageinfo .= " <strong>$vpnum</strong>"; }
   else{ $pageinfo .= " <a href=\"$gest_url\?m\=$curmnum\">$vpnum</a>"; }
   $vpnum++;
   }
 }
else{ $pageinfo .= "(  )"; }
print <<EOF;
       <tr><td colspan=2>$pageinfo</table>
       <hr><table width="100%"><tr><td width="70%">
       <table><tr><td colspan=2><h2><a name="new"></a> </h2>
       <form name="sf" method="POST" action="$gest_url"
       onsubmit="return check_sf()">
       <input type="hidden" name="c" value="Add">
       <tr>
       <td colspan="2">,  <sup><strong>*</strong></sup>
         
       <tr>
       <td><b>  : <sup><strong>*</strong></sup></b>
       <td><input type="text" name="nick">
       <tr>
       <td><b>E-mail:</b>
       <td><input type="text" name="email" size="50">
       <tr>
       <td><b> :</b>
       <td><input type="text" name="site" size="50">
       <tr>
       <td><b> </b><br>(ICQ, IRC  ..):
       <td><textarea name="cont" rows="3" cols="35" class="cn"></textarea>
       <tr>
       <td colspan="2">
       <input type="checkbox" name="e" value="y" id="eid">
       <label for="eid"> e-mail,    ( ,
        )</label>
       <tr>
       <td><b>: <sup><strong>*</strong></sup></b>
       <td><textarea name="msg" rows="7" cols="35"></textarea>
       <tr>
       <td><b>: <sup><strong>*</strong></sup></b>
       <td><select name="forwho">
       <option value="all" selected> </option>
       <option value="adm"> </option>
       </select>
       <tr>
       <td colspan="2"><fieldset><legend> :</legend>
       <input type="checkbox" name="ab" value="y" id="abid" checked>
       <label for="abid"> BB-</label><br>
       <input type="checkbox" name="ane" value="y" id="aneid" checked>
       <label for="aneid"> HTML Named Entities</label><br>
       <input type="checkbox" name="as" value="y" id="asid" checked>
       <label for="asid"> </label>
       </fieldset>
       <tr>
       <td colspan="2" align="center"><input type="submit"
       value=" ">
       <tr><td colspan=2><small>    
            ,  .
             ,   .</small>
       <tr>
       <td><b>:</b>
       <td><input type="password" name="pass">
       <tr>
       <td><b>  :</b>
       <td><input type="password" name="pass2">
       <input type="hidden" name="crc"><input type="hidden" name="crcdva">
       </form></table><td width="30%" class="fmt" valign="middle">
       <script language="JavaScript">format_ctrls();</script>
       </table>
       $modenote
       <hr><form name="Lf" method="POST" action="$gest_url"
       onsubmit="return check_Lf()">
       <p align="center">Powered by <a
       href="http://super-m.savesoul.ru/support/htmljava.htm"><b>SM GB</b></a>
       v. 2.6, 2003-2023</p>
       <p class="safe"><b>   </b><br>
       : <input type="text" name="amask">;
       : <input type="password" name="apass">
       <input type="hidden" name="c" value="Login">
       <input type="submit" value=""><br>
       <small>(   ,  
         &laquo; &raquo;     
       + <b></b>  )</small></p></form>
       <script language="JavaScript">pre_init();</script>
       <!--  : Super-M, http://super-m.savesoul.ru/ --></body></html>
EOF
exit();
}

sub print_msg{
my($otvet, $answ2, $nick2, $citeta);
$allow_print=1;
$aform="";
$misc="";
$answtext="";
if ($us =~ /A/){
  if ($isadm == 0){
   if (($amask ne $nick)||($apw ne $password)||($password eq ""))
    { $allow_print=0; }
   else { $misc .= "<tr><td colspan=2><strong><i>\(-    -\)</i></strong>"; }
   }
  else { $misc .= "<tr><td colspan=2><strong>- FOR ADMIN ONLY -</strong>"; }
  }
if ($allow_print==1){
  if ($isadm == 1){
   $aform = "<tr><td colspan=2>Posted from: <b>$ip</b><br>";
   $aform .= "<form method=\"POST\" action=\"$gest_url\">\n";
   $aform .= "<input type=\"hidden\" name=\"c\" value=\"Delete\">";
   $aform .= "<input type=\"hidden\" name=\"umid\" value=\"$umid\">";
   $aform .= "<input type=\"hidden\" name=\"m\" value=\"$mnum\">";
   $aform .= "<input type=\"submit\" value=\" \"></form>\n";
   if ($answer eq ""){ $otvet=""; }
   else { $otvet=" "; }
   $answ2 = encode_profile($answer);
   if (($us !~ /A/)||($password ne "")){
      $aform .= "<form method=\"POST\" action=\"$gest_url\">\n";
      $aform .= "<input type=\"submit\" value=\"$otvet\">";
      $aform .= "<input type=\"hidden\" name=\"c\" value=\"Answer\">";
      $aform .= "<input type=\"hidden\" name=\"m\" value=\"$mnum\">";
      $aform .= "<textarea name=\"answer\" rows=5 cols=35>$answ2</textarea>";
      $aform .= "<input type=\"hidden\" name=\"umid\" value=\"$umid\"></form>\n";
      }
   else { $aform .= "<br><b> <i>   </i></b>"; }
   }
  $date=&encode_misc($date);
  $nick=&encode_misc($nick);
  $nick =~ s/\"/\'\'/g; $nick =~ s/\'/&#039;/g;
  $cont=&encode_info($cont); $cont = &filter_url($cont);
  $msg=&encode_info($msg);
  $citeta=&encode_profile($msg);
  $nick2="<a href=\'javascript:insNick(\"$nick\")\' class=\'nick\' title=\'   \'>$nick</a>";
  if ($us =~ /I/) { $nick2=$nick2." <strong>\(\)</strong>"; }
  if ($us =~ /B/) { $msg=&encode_bb($msg); }
  if ($us =~ /S/) { $msg=&encode_sm($msg); }
  if ($answer ne ""){
    $answer=&encode_info($answer); $answer=&encode_sm($answer);
    $answtext = "<tr><td colspan=2 class=\"answer\"><em>  $admLinkNick:</em><br>$answer";
    }
  if (($isadm == 1)&&($us =~ /E/)) { $cont .= "<br><strong>  , . !</strong>"; }
  if (($isadm == 0)&&($us =~ /E/)) { $cont = "<strong>    !</strong>"; }
  print <<EOF;
       <tr><td colspan=2><hr>
       <tr>
       <td>:<td>$date
       <tr>
       <td>:<td><b>$nick2</b>
       <tr>
       <td><b>:</b>
       <td>$cont
       $misc
       <tr>
       <td colspan="2" class="msg">$msg
       <tr>
       <td><a href='javascript:citeMsg("$nick","$nmsgs")'
       class='nick'> </a>
       <td><form name="f$nmsgs" style="display:none">
       <textarea name="t" rows="1" cols="7"
       style="display:none">$citeta</textarea>
       </form>
       $answtext
       $aform
       <tr><td colspan=2 align="center"><a href="#new"> </a>
EOF
  }
}

sub encode_profile{ #for editing multiline
my($ret)=$_[0];
$ret =~ s/<br>/\n/g;
$ret =~ s/</&lt;/g; $ret =~ s/>/&gt;/g;
$ret;
}

sub encode_reg{ #for storing
my($ret)=$_[0];
$ret =~ s/\n/<br>/g; $ret =~ s/\t//g;
$ret;
}

sub encode_info{ #for display multiline
my($ret)=$_[0];
$ret =~ s/</&lt;/g; $ret =~ s/>/&gt;/g;
$ret =~ s/&lt;br&gt;/<br>/g;
$ret =~ s/  / &nbsp;/g;
$ret;
}

sub encode_misc{ #for display others
my($ret)=$_[0];
$ret =~ s/</&lt;/g; $ret =~ s/>/&gt;/g;
$ret =~ s/  / &nbsp;/g;
$ret;
}

sub encode_amp{ #to disable named entities
my($ret)=$_[0];
$ret =~ s/&/&amp;/g;
$ret;
}

sub encode_sm{ #to display smiles
my($ret)=$_[0];
$ret =~ s/\:\)\)\)/<img src=\"\/img\/smile3.gif\" border=\"0\">/g;
$ret =~ s/\:-\)\)\)/<img src=\"\/img\/smile3.gif\" border=\"0\">/g;
$ret =~ s/\:\)\)/<img src=\"\/img\/smile2.gif\" border=\"0\">/g;
$ret =~ s/\:-\)\)/<img src=\"\/img\/smile2.gif\" border=\"0\">/g;
$ret =~ s/&gt;\:\)/<img src=\"\/img\/smile4.gif\" border=\"0\">/g;
$ret =~ s/&gt;\:-\)/<img src=\"\/img\/smile4.gif\" border=\"0\">/g;
$ret =~ s/\:\)/<img src=\"\/img\/smile1.gif\" border=\"0\">/g;
$ret =~ s/\:-\)/<img src=\"\/img\/smile1.gif\" border=\"0\">/g;
$ret =~ s/&gt;\:&gt;/<img src=\"\/img\/smile6.gif\" border=\"0\">/g;
$ret =~ s/&gt;\:-&gt;/<img src=\"\/img\/smile6.gif\" border=\"0\">/g;
$ret =~ s/\:&gt;/<img src=\"\/img\/smile5.gif\" border=\"0\">/g;
$ret =~ s/\:-&gt;/<img src=\"\/img\/smile5.gif\" border=\"0\">/g;
$ret =~ s/\:D/<img src=\"\/img\/smile7.gif\" border=\"0\">/g;
$ret =~ s/\:-D/<img src=\"\/img\/smile7.gif\" border=\"0\">/g;
$ret =~ s/B-\)/<img src=\"\/img\/smile8.gif\" border=\"0\">/g;
$ret =~ s/\:\|/<img src=\"\/img\/smile9.gif\" border=\"0\">/g;
$ret =~ s/\:-\|/<img src=\"\/img\/smile9.gif\" border=\"0\">/g;
$ret =~ s/\:\(\(/<img src=\"\/img\/smile11.gif\" border=\"0\">/g;
$ret =~ s/\:-\(\(/<img src=\"\/img\/smile11.gif\" border=\"0\">/g;
$ret =~ s/\:\(/<img src=\"\/img\/smile10.gif\" border=\"0\">/g;
$ret =~ s/\:-\(/<img src=\"\/img\/smile10.gif\" border=\"0\">/g;
$ret =~ s/\:&lt;/<img src=\"\/img\/smile11.gif\" border=\"0\">/g;
$ret =~ s/\:-&lt;/<img src=\"\/img\/smile11.gif\" border=\"0\">/g;
$ret =~ s/\:\*/<img src=\"\/img\/smile12.gif\" border=\"0\">/g;
$ret =~ s/\:-\*/<img src=\"\/img\/smile12.gif\" border=\"0\">/g;
$ret;
}

sub encode_ww{ #to display wrong word
my($ret)=$_[0];
$ret =~ s/&/&amp;/g; $ret =~ s/\"/&quot;/g;
$ret =~ s/</&lt;/g; $ret =~ s/>/&gt;/g;
$ret;
}


sub encode_cookie{
my($ret)=$_[0];
foreach $char (keys %Cookie_Encode_Chars) {
  $ret =~ s/$char/$Cookie_Encode_Chars{$char}/g;
  }
$ret;
}

sub encode_bb{ #BB coding
my($ret, @kuski, $outpart, $inpart);
@kuski = split(/\[\/XMP\]/i, $_[0]);
$ret="";
foreach $kusok (@kuski){
 ($outpart, $inpart) = split(/\[XMP\]/i, $kusok);
 if ($outpart ne ""){
  foreach $thekod (@sbbcodes){ $outpart = &filter_sbb($outpart, $thekod); }
  foreach $thekod (@fbbcodes){ $outpart = &filter_font($outpart, $thekod); }
  $outpart = &filter_url($outpart);
  $outpart = &filter_quo($outpart);
  }
 $ret .= $outpart;
 if ($inpart ne ""){$ret .= "\n<!--XMP-->\n<br>$inpart<br>\n<!--/XMP-->";}
 }
$ret;
}

sub filter_sbb{ #simple BB codes
my($some, @parts, $fpart, $spart);
@parts = split(/\[\/$_[1]\]/i, $_[0]);
$some="";
foreach $piece (@parts){
  ($fpart, $spart) = split(/\[$_[1]\]/i, $piece);
  $some .= $fpart;
  if ($spart ne ""){$some .= "\<$_[1]\>$spart\<\/$_[1]\>";}
  }
$some;
}

sub filter_font{ #font BB codes
my($some, @parts, $fpart, $spart, $thpart, $frpart);
@parts = split(/\[\/$_[1]\]/i, $_[0]);
$some="";
foreach $piece (@parts){
  ($fpart, $spart) = split(/\[$_[1] /i, $piece);
  if ($spart eq ""){ ($fpart, $spart) = split(/\[$_[1]\=/i, $piece); }
  if ($spart ne ""){
   $spart =~ s/\]/<dog>/;
   ($thpart, $frpart) = split(/<dog>/, $spart);
   if ($frpart ne ""){
    $thpart =~ s/\"//g; $thpart =~ s/\'//g; $thpart =~ s/&//g;
    $some .= "$fpart<font $_[1]\=\"$thpart\">$frpart<\/font>";
    }
   else{ $some .= $piece; }
   }
  else{ $some .= $piece; }
  }
$some;
}

sub filter_url{ #URL BB codes
my($some, @parts, $fpart, $spart, $thpart, $frpart);
@parts = split(/\[\/URL\]/i, $_[0]);
$some="";
foreach $piece (@parts){
 if ($piece =~ /\[URL\]/i){
  ($fpart, $spart) = split(/\[URL\]/i, $piece);
  if ($spart ne ""){
    $spart =~ s/\"//g; $spart =~ s/\'//g;
    if ($spart !~ /\:/){ $spart = "http://$spart"; }
    $some .= "$fpart<a href\=\"$spart\">$spart<\/a>";
  }
  else{ $some .= $piece; }
 }
 else {
  ($fpart, $spart) = split(/\[URL /i, $piece);
  if ($spart eq ""){ ($fpart, $spart) = split(/\[URL\=/i, $piece); }
  if ($spart ne ""){
   $spart =~ s/\]/<dog>/;
   ($thpart, $frpart) = split(/<dog>/, $spart);
   if ($frpart ne ""){
    $thpart =~ s/\"//g; $thpart =~ s/\'//g;
    if ($thpart !~ /\:/){ $thpart = "http://$thpart"; }
    $some .= "$fpart<a href\=\"$thpart\">$frpart<\/a>";
    }
   else{ $some .= $piece; }
   }
  else{ $some .= $piece; }
  }
 }
$some;
}

sub filter_quo{ #quote BB codes
my($some, @parts, $fpart, $spart, $thpart, $frpart);
@parts = split(/\[\/QUOTE\]/i, $_[0]);
$some="";
foreach $piece (@parts){
 if ($piece =~ /\[QUOTE\]/i){
  ($fpart, $spart) = split(/\[QUOTE\]/i, $piece);
  if ($spart ne ""){
    $spart =~ s/\"//g; $spart =~ s/\'//g;
    $some .= "$fpart<div class\=\"cite1\">:<\/div><div class\=\"cite2\">$spart<\/div>";
  }
  else{ $some .= $piece; }
 }
 else {
  ($fpart, $spart) = split(/\[QUOTE /i, $piece);
  if ($spart eq ""){ ($fpart, $spart) = split(/\[QUOTE\=/i, $piece); }
  if ($spart ne ""){
   $spart =~ s/\]/<dog>/;
   ($thpart, $frpart) = split(/<dog>/, $spart);
   if ($frpart ne ""){
    $thpart =~ s/\"//g; $thpart =~ s/\'//g;
    $some .= "$fpart<div class\=\"cite1\"><b>$thpart</b> \(\):<\/div><div class\=\"cite2\">$frpart<\/div>";
    }
   else{ $some .= $piece; }
   }
  else{ $some .= $piece; }
  }
 }
$some;
}

sub add_msg{
# my($fnd,$nk,$pw);
# $fnd=0; $pass=$data{'pass'};
my($crc1,$crc2);
my($flw,$wrongword,@words,$word,$wlen);
$nick=$data{'nick'}; $passtwo=$data{'pass2'}; $cont=$data{'cont'};
$msg=$data{'msg'}; $forwho=$data{'forwho'}; $us="U";
$crc1=$data{'crc'}+0; $crc2=$data{'crcdva'}+0;
$crc1=$crc1*27-285;
if ($crc1 != $crc2){
  $err_msg = "<p>  !</p>";
  &print_err;
  }
if ($remotehost eq '83.102.169.8'){
  $err_msg = "<p>  !</p>";
  &print_err;
  }
if ($cont =~ /rassilka\.83/i){
  $err_msg = "<p>  !</p>";
  &print_err;
  }
@words = split(/[ .,:;!?\\\/\-\+\-\=\n\r\t\[\]]/, $msg);
$flw = 0;
foreach $word (@words){
  $wlen = length($word);
  if ($wlen > 50){ $flw=1; $wrongword=&encode_ww($word); }
}
if ($flw == 1){
  $err_msg = "<p> !    <b>$wrongword</b>.</p>";
  &print_err;
  }
@words = split(/[ .,:;!?\\\/\-\+\-\=\n\r\t\[\]]/, $cont);
$flw = 0;
foreach $word (@words){
  $wlen = length($word);
  if ($wlen > 50){ $flw=1; $wrongword=&encode_ww($word); }
}
if ($flw == 1){
  $err_msg = "<p> !    <b>$wrongword</b>.</p>";
  &print_err;
  }
if (length($nick) > 100){
  $err_msg = "<p> !      100 .</p>";
  &print_err;
  }
if (length($pass) > 100){
  $err_msg = "<p> !      100 .</p>";
  &print_err;
  }
if (length($forwho) > 10){
  $err_msg = "<p>    !</p>";
  &print_err;
  }
if (length($cont) > 1000){
  $err_msg = "<p> !   &quot;&quot;    1000 .</p>";
  &print_err;
  }
if (length($msg) > 5000){
  $err_msg = "<p> !       5000 .</p>";
  &print_err;
  }
if ($nick eq ""){
  $err_msg = "<p class=\"bad\">:    !</p>";
  &show_all;
  }
if (($nick eq $admName)&&($isadm == 0)){
  $err_msg = "<p class=\"bad\">     
   <strong>$admName</strong>.    .</p>";
  &show_all;
  }
if ($pw ne $passtwo){
  $err_msg = "<p class=\"bad\">     .</p>";
  &show_all;
  }
if ($forwho eq "adm") { $us .= "A"; }
if ($isadm == 1) { $us .= "I"; }
if ($data{'ab'} eq "y") { $us .= "B"; }
if ($data{'ane'} ne "y") { $msg=&encode_amp($msg); }
if ($data{'as'} eq "y") { $us .= "S"; }
if ($data{'e'} eq "y") { $us .= "E"; }
$nick=&encode_reg($nick);
$cont=&encode_reg($cont); $msg=&encode_reg($msg);
$date=&get_date(); $umid="$date $remotehost";
$answer="";
open(AFILE, "+<$path_to_gest");
my(@lines) = <AFILE>;
flock(AFILE, 2); seek(AFILE, 0, 0);
my(@templast, @datenow, @datewas);
my($doit, $thesize, $line, $linesz, $sameipposts);
$doit=1; $thesize=0; $sameipposts=0;
@datenow=split(/\:/, $date);
foreach $line (@lines){ #in this loop thesize is count
 if ($thesize < 5){
  @templast=split(/\t/, $line);
  if (($templast[4] eq $msg)&&($templast[1] eq $nick))
  { $doit=0; $err_msg = "<p>  </p>"; }
  if ($templast[7] eq $remotehost){
   @datewas=split(/\:/, $templast[8]);
   if ($datenow[0] eq $datewas[0]){ $sameipposts++; }
   }
  }
 $thesize++;
 }
if (($sameipposts > 2)&&($doit == 1)){ $doit=0; }
# $umid,$nick,$password,$cont,$msg,$answer,$us,$ip,$date
if ($doit == 1){
 $line="$umid\t$nick\t$pw\t$cont\t$msg\t$answer\t$us\t$remotehost\t$date\n";
 print AFILE $line;
 $thesize = length($line); #from here thesize is file size
 foreach $line (@lines){
  $linesz = length($line);
  if(($thesize + $linesz) > 200000){ $doit=0; }
  if ($doit == 1){
   print AFILE $line;
   $thesize += $linesz;
   }
  }
 truncate(AFILE, $thesize);
 $err_msg = "<p>   .</p>";
 }
flock(AFILE, 8);
close(AFILE);
if (($sameipposts > 2)&&($err_msg eq "")){
  $err_msg = "<p> !      .    .</p>";
  &print_err;
  }
&show_all;
}

sub do_login{
$amask = $data{'amask'};
$apw = $data{'apass'};
if (($amask eq "")&&($apw eq "")){
 $addhdr = "Set-Cookie: amask=\nSet-Cookie: apass=\n";
 }
elsif ($amask eq ""){
  $err_msg = "<p class=\"bad\">:    .</p>";
 }
if (($amask eq $admName)&&($apw eq $admPassw)) { $isadm=1; }
else { $isadm=0; }
&show_all;
}

sub add_answ{
if ($isadm == 0){
  $err_msg = "<p class=\"bad\">: Answer   !</p>";
  &show_all;
  }
my($umidd) = $data{'umid'};
my($newansw) = $data{'answer'};
$newansw=&encode_reg($newansw);
my(@fdata);
my($fnd) = 0;
local $/ = undef;
open(ANFILE, "+<$path_to_gest");
flock(ANFILE, 2);
@fdata = split(/\n/, <ANFILE>);
foreach $line (@fdata){
  if ($line =~ /^$umidd\t/){
   ($umid,$nick,$password,$cont,$msg,$answer,$us,$ip,$date) = split(/\t/, $line);
   $stuff .= "$umid\t$nick\t$password\t$cont\t$msg\t$newansw\t$us\t$ip\t$date\n";
   $fnd = 1;
   }
  else { $stuff .= "$line\n"; }
  }
truncate(ANFILE, length($stuff));
seek(ANFILE, 0, 0);
print ANFILE $stuff;
close(ANFILE);
undef $stuff;
$/ = "\n";
@fdata = ( );
if ($fnd == 1) { $err_msg = "<p>  .</p>"; }
else { $err_msg = "<p class=\"bad\">  !   .</p>"; }
&show_all;
}

sub del_msg{
if ($isadm == 0){
  $err_msg = "<p class=\"bad\">: Delete   !</p>";
  &show_all;
  }
my($umidd) = $data{'umid'};
my(@fdata);
my($fnd) = 0;
local $/ = undef;
open(DFILE, "+<$path_to_gest");
flock(DFILE, 2);
@fdata = split(/\n/, <DFILE>);
foreach $line (@fdata){
  if ($line =~ /^$umidd\t/) { $fnd = 1; }
  else { $stuff .= "$line\n"; }
  }
truncate(DFILE, length($stuff));
seek(DFILE, 0, 0);
print DFILE $stuff;
close(DFILE);
undef $stuff;
$/ = "\n";
@fdata = ( );
if ($fnd == 1) { $err_msg = "<p>  .</p>"; }
else { $err_msg = "<p class=\"bad\">:   !</p>"; }
&show_all;
}


sub print_err {
print "Pragma: no-cache\nContent-Type: text/html; charset=windows-1251\n\n";
print "<html><head><title>$admLinkNick : </title>\n";
print "<style type=\"text/css\">\nbody {background-color:red; color:yellow}\n";
print "</style>\n</head>\n";
print "<body><h1></h1>$err_msg\n<p align=\"center\"><a
  href=\"javascript:history.back\(\)\"></a></p></body></html>";
exit();
}

sub get_date {
   ($sec,$min,$hour,$mday,$mon,$year) = (localtime($time))[0,1,2,3,4,5];
   $mon = $mon + 1;
   if ($hour < 10) { $hour = "0$hour"; }
   if ($min < 10) { $min = "0$min"; }
   if ($sec < 10) { $sec = "0$sec"; }
   $year += 1900;
   $date = "$mday.$mon.$year $hour\:$min\:$sec";
   $date;
}


sub get_data {
    my($string, @adata, %data, @dt);

    # get data
    if ($ENV{'REQUEST_METHOD'} eq 'GET') {
        $string = $ENV{'QUERY_STRING'};
    }				
    else { read(STDIN, $string, $ENV{'CONTENT_LENGTH'}); }

    # split data into name=value pairs
    @adata = split(/&/, $string);
   
    # split into name=value pairs in associative array
    foreach (@adata) {
        @dt = split(/=/, $_);
        $dt[0] =~ s/\+/ /g; # plus to space
        $dt[0] =~ s/\%00//g;
        $dt[0] =~ s/%(..)/pack("c", hex($1))/ge; # hex to alphanumeric
        $dt[0] =~ s/\r\n/\n/g;
        $dt[0] =~ s/\r/\n/g;
        if(defined($data{$_[0]})){ 
           $data{$dt[0]} .= "\0";
           $data{$dt[0]} .= "$dt[1]";
           }
        else {
          $data{"$dt[0]"} = $dt[1];
          }
    }
    # translate special characters
    foreach (keys %data) {
     $data{"$_"} =~ s/\+/ /g; # plus to space
     $data{"$_"} =~ s/%(..)/pack("c", hex($1))/ge; # hex to alphanumeric
     $data{"$_"} =~ s/\r\n/\n/g;
     $data{"$_"} =~ s/\r/\n/g;
    }

    %data;			# return associative array of name=value
}
